package com.jeeplus.modules.sg.overheadline.service;

import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.common.utils.sg.ExcelUtil;
import com.jeeplus.modules.sg.overheadline.entity.Settlement;
import com.jeeplus.modules.sg.overheadline.mapper.SettlementMapper;
import com.jeeplus.modules.sg.overheadline.util.BashInfo;
import com.jeeplus.modules.sg.overheadline.util.SettementUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.util.*;

@Service
public class SettlementService {
    @Autowired
    private SettlementMapper settlementMapper;

    /*
        添加结算工程表
     */
    @Transactional
    public void save(Map<String,Object[]> builtMap, double builtTotal, double[] divisiontotal, double wordtotal, double otherTotal, double feescount, String id){
        List<Settlement> settlementList = BashInfo.getTotality(builtMap,builtTotal,divisiontotal,wordtotal,otherTotal,feescount,id);
        for (Settlement settlement:settlementList){
            settlementMapper.sava(settlement);
        }
    }
    /*
        查找结算工程表
     */
    public List<Settlement> selectSettlementService(String id){
        List<Settlement> settlementList =  settlementMapper.selectSettlement(id);
        Double money;
        String theAmout;
        String[] amout;
        String status;
        String reason;
        for(Settlement settlement:settlementList){
            money=0.0;
            reason="";
            String key = settlement.getEntryName();
            switch (key){
                case BashInfo.JS_FBFX:
                   money = settlement.getMoney();
                   theAmout =  settlement.getTheAmount();
                   amout = theAmout.split(",");
                   status = settlement.getStatus();
                   reason = SettementUtil.RESON_FBFX1.replaceAll("xxx",String.valueOf(money)).replace("yyy",amout[0]);
                   settlement.setReason(reason);
                    break;
                case  BashInfo.JS_CBRF:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    reason = SettementUtil.RESON_CBRF.replaceAll("xxx",String.valueOf(money)).replace("yyy",theAmout);
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_CSXM:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    reason = SettementUtil.RESON_CSXM.replaceAll("xxx",String.valueOf(money)).replace("yyy",theAmout).replace("zzz","0.0").replace("ddd",String.valueOf(money));
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_QTXM:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    reason = SettementUtil.RESON_QTXM.replaceAll("xxx",String.valueOf(money)).replace("yyy",theAmout);
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_GF:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    reason = SettementUtil.RESON_GF.replaceAll("xxx",String.valueOf(money)).replace("yyy",theAmout);
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_SJ:
                    reason = SettementUtil.RESON_SJ;
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_FBRF:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    reason = SettementUtil.RESON_FBRF.replaceAll("xxx",String.valueOf(money)).replace("yyy",theAmout);
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_JGJS:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    amout = theAmout.split(",");
                    reason = SettementUtil.RESON_JGJS.replace("xxx",String.valueOf(money)).replace("yyy",amout[0]).replace("zzz",amout[1]).replace("qqq",amout[2]).replace("www",amout[3]).replace("nnn",amout[4]).replace("eee",amout[5]).replace("rrr",amout[6]).replace("ttt",amout[7]);
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_BZZS:
                    reason = SettementUtil.RESON_BZZS;
                    settlement.setReason(reason);
                    break;
                case BashInfo.JS_KJJG:
                    reason = SettementUtil.RESON_KJJG;
                    settlement.setReason(reason);
                    break;
                case BashInfo.GCJS:
                    money = settlement.getMoney();
                    theAmout =  settlement.getTheAmount();
                    amout=theAmout.split(",");
                    reason = SettementUtil.RESON_GCJS.replace("xxx",String.valueOf(money)).replace("yyy",amout[0]).replace("zzz",amout[1]).replace("www",amout[2]).replace("ddd",amout[3]);
                    settlement.setReason(reason);
                    break;
            }
        }

        return settlementList;
    }

    public void delete(String id){
        settlementMapper.delete(id);
    }
}
